<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE sect1 PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
   "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
  <!ENTITY % general-entities SYSTEM "../../general.ent">
  %general-entities;

  <!ENTITY freerdp-download-http "https://github.com/freerdp/freerdp/archive/&freerdp-version;/FreeRDP-&freerdp-version;.tar.gz">
  <!ENTITY freerdp-md5sum        "14ec84b674483893e4f53afedf014e39">
  <!ENTITY freerdp-size          "9.9 MB">
  <!ENTITY freerdp-buildsize     "135 MB">
  <!ENTITY freerdp-time          "0.2 SBU (Using parallelism=4)">
]>

<sect1 id="freerdp" xreflabel="FreeRDP-&freerdp-version;">
  <?dbhtml filename="freerdp.html"?>

  <title>FreeRDP-&freerdp-version;</title>

  <indexterm zone="freerdp">
    <primary sortas="a-freerdp">FreeRDP</primary>
  </indexterm>

  <sect2 role="package">
    <title>Introduction to FreeRDP</title>

    <para>
      The <application>FreeRDP</application> package contains libraries and
      utilities for utilizing the Remote Desktop Protocol. This includes tools
      to run an RDP server as well as to connect to a computer using RDP. This
      is primarily used for connecting to Microsoft Windows computers, but can
      also be used on Linux and macOS.
    </para>

    &lfs122_checked;

    <bridgehead renderas="sect3">Package Information</bridgehead>
    <itemizedlist spacing="compact">
      <listitem>
        <para>
          Download (HTTP): <ulink url="&freerdp-download-http;"/>
        </para>
      </listitem>
      <listitem>
        <para>
          Download MD5 sum: &freerdp-md5sum;
        </para>
      </listitem>
      <listitem>
        <para>
          Download size: &freerdp-size;
        </para>
      </listitem>
      <listitem>
        <para>
          Estimated disk space required: &freerdp-buildsize;
        </para>
      </listitem>
      <listitem>
        <para>
          Estimated build time: &freerdp-time;
        </para>
      </listitem>
    </itemizedlist>

    <bridgehead renderas="sect3">FreeRDP Dependencies</bridgehead>

    <bridgehead renderas="sect4">Required</bridgehead>
    <para role="required">
      <xref linkend="ffmpeg"/>,
      <xref linkend="icu"/>, and
      <xref linkend="xorg7-lib"/>
    </para>

    <bridgehead renderas="sect4">Recommended</bridgehead>
    <para role="recommended">
      <xref linkend="cairo"/>,
      <xref linkend="docbook-xsl"/>,
      <xref linkend="fuse3"/>,
      <xref linkend="json-c"/>,
      <xref linkend="mitkrb"/>,
      <xref linkend="libusb"/>,
      <xref linkend="libxkbcommon"/>, and
      <xref linkend="wayland"/>
    </para>

    <bridgehead renderas="sect4">Optional</bridgehead>
    <para role="optional">
      <xref linkend="cups"/>,
      <xref linkend="faac"/>,
      <xref linkend="faad2"/>,
      <xref linkend="fdk-aac"/>,
      <xref linkend="lame"/>,
      <xref linkend="linux-pam"/>,
      <xref linkend="pulseaudio"/>,
      <ulink url="https://github.com/DaveGamble/cJSON">cJSON</ulink>,
      <ulink url="https://www.quut.com/gsm/">GSM</ulink>,
      <ulink url="https://github.com/OCL-dev/ocl-icd">ocl-icd</ulink>,
      <ulink url="https://github.com/Mbed-TLS/mbedtls">mbedTLS</ulink>,
      <ulink url="https://www.openh264.org/">openh264</ulink>,
      <ulink url="https://pcsclite.apdu.fr/">pcsclite</ulink>,
      <ulink url="https://github.com/libsdl-org/SDL_ttf">SDL_ttf</ulink>,
      <ulink url="https://github.com/chirlu/soxr">soxr</ulink>, and
      <ulink url="https://github.com/uriparser/uriparser">uriparser</ulink>
    </para>

  </sect2>

  <sect2 role="installation">
    <title>Installation of FreeRDP</title>

    <para>
      Install <application>FreeRDP</application> by running the following
      commands:
    </para>

<screen><userinput>mkdir build &amp;&amp;
cd    build &amp;&amp;

cmake -D CMAKE_INSTALL_PREFIX=/usr   \
      -D CMAKE_SKIP_INSTALL_RPATH=ON \
      -D CMAKE_BUILD_TYPE=Release    \
      -D WITH_CAIRO=ON               \
      -D WITH_CLIENT_SDL=OFF         \
      -D WITH_DSP_FFMPEG=ON          \
      -D WITH_FFMPEG=ON              \
      -D WITH_PCSC=OFF               \
      -D WITH_SERVER=ON              \
      -D WITH_SERVER_CHANNELS=ON     \
      -D DOCBOOKXSL_DIR=/usr/share/xml/docbook/xsl-stylesheets-nons-&docbook-xsl-version; \
      -W no-dev                      \
      -G Ninja ..                    &amp;&amp;
ninja</userinput></screen>

    <para>
      This package does not come with a test suite.
    </para>

    <para>
      Now, as the &root; user:
    </para>

<screen role="root"><userinput>ninja install</userinput></screen>

  </sect2>

  <sect2 role="commands">
    <title>Command Explanations</title>

    <xi:include xmlns:xi="http://www.w3.org/2001/XInclude"
      href="../../xincludes/cmake-skip-install-rpath.xml"/>

    <para>
      <parameter>-D DOCBOOKXSL_DIR=/usr/share/xml/docbook/xsl-stylesheets-nons-&docbook-xsl-version;</parameter>:
      This parameter points CMake to the location of the Docbook XSL
      stylesheets, and is needed because BLFS does not use namespaced versions
      of the stylesheets. This is needed to create man pages. If you do not
      want manpages, pass -D WITH_MANPAGES=OFF to CMake instead.
    </para>

    <para>
      <parameter>-D WITH_CAIRO=ON</parameter>: This parameter uses Cairo for
      HighDPI and window resizing support.
    </para>

    <para>
      <parameter>-D WITH_CLIENT_SDL=OFF</parameter>: This parameter disables
      using SDL to draw the window when using the FreeRDP client. This is
      disabled because it depends on
      <ulink url="https://github.com/libsdl-org/SDL_ttf">SDL_ttf</ulink>.
      Remove this switch if you have the SDL_ttf package installed.
    </para>

    <para>
      <parameter>-D WITH_FFMPEG=ON</parameter>: This parameter enables support
      for using ffmpeg for the H.264 graphics rendering mode, which is required
      when connecting via RDP to Windows Server 2012 (or Windows 8) or later
      hosts.
    </para>

    <para>
      <parameter>-D WITH_DSP_FFMPEG=ON</parameter>: This parameter enables
      support for using ffmpeg for sound and microphone redirection.
    </para>

    <para>
      <parameter>-D WITH_PCSC=OFF</parameter>: This parameter disables support
      for SmartCards since BLFS does not have the required dependency for it.
    </para>

    <para>
      <parameter>-D WITH_SERVER=ON</parameter>: This parameter enables building
      the FreeRDP server components. Remove this parameter if you do not want
      to use the FreeRDP server.
    </para>

    <para>
      <parameter>-D WITH_SERVER_CHANNELS=ON</parameter>: This parameter builds
      additional plugins for the FreeRDP server.
    </para>

    <para>
      <option>-D WITH_LAME=ON</option>: Use this option if you wish to enable
      support for using LAME to provide MP3 Audio Codec support.
    </para>
    
    <para>
      <option>-D WITH_FAAC=ON</option>: Use this option if you wish to enable
      support for using FAAC to provide AAC Audio Codec support.
    </para>
    
    <para>
      <option>-D WITH_FAAD2=ON</option>: Use this option if you wish to enable
      support for using FAAD2 to provide AAC Audio Codec support.
    </para>

    <para>
      <option>-D WITH_FDK_AAC=ON</option>: Use this option if you wish to
      enable support for using fdk-aac to provide AAC Audio Codec support.
    </para>

    <para>
      <option>-D WITH_MBEDTLS=ON</option>: Use this option if you have the
      optional dependency
      <ulink url="https://github.com/Mbed-TLS/mbedtls">mbedTLS</ulink> installed
      and wish to use it as an alternative to OpenSSL for cryptography support.
    </para>

    <para>
      <option>-D WITH_OPENCL=ON</option>: Use this option if you have the
      optional dependency
      <ulink url="https://github.com/OCL-dev/ocl-icd">ocl-icd</ulink>
      installed and wish to use OpenCL support.
    </para>

    <para>
      <option>-D WITH_OPENH264=ON</option>: Use this option if you have
      the optional dependency
      <ulink url="https://www.openh264.org/">openh264</ulink> installed and
      wish to use it for H.264 support instead of ffmpeg.
    </para>
    
    <para>
      <option>-D WITH_GSM=ON</option>: Use this option if you have the optional
      dependency <ulink url="https://www.quut.com/gsm/">GSM</ulink> installed
      and wish to use GSM as an audio codec.
    </para>
    
    <para>
      <option>-D WITH_SOXR=ON</option>: Use this option if you have the optional
      dependency <ulink url="https://github.com/chirlu/soxr">soxr</ulink>
      installed and wish to use it instead of ffmpeg for multimedia redirection.
    </para>
    
  </sect2>

  <sect2 role="content">
    <title>Contents</title>

    <segmentedlist>
      <segtitle>Installed Programs</segtitle>
      <segtitle>Installed Libraries</segtitle>
      <segtitle>Installed Directories</segtitle>

      <seglistitem>
        <seg>
          freerdp-proxy,
          freerdp-shadow-cli,
          sfreerdp,
          sfreerdp-server,
          winpr-hash,
          winpr-makecert,
          wlfreerdp,
          xfreerdp
        </seg>
        <seg>
          libfreerdp3.so,
          libfreerdp-client3.so,
          libfreerdp-server3.so,
          libfreerdp-server-proxy3.so,
          libfreerdp-shadow3.so,
          libfreerdp-shadow-subsystem3.so,
          librtdk0.so,
          libuwac0.so,
          libwinpr3.so, and
          libwinpr-tools3.so
        </seg>
        <seg>
          /usr/include/{freerdp3,rdtk0,uwac0,winpr3},
          /usr/lib/cmake/{FreeRDP3,FreeRDP-Client3,FreeRDP-Proxy3,FreeRDP-Server3,rdtk0,uwac0,WinPR3,WinPR-tools3},
          /usr/lib/freerdp3,
          /usr/share/FreeRDP
        </seg>
      </seglistitem>
    </segmentedlist>

    <variablelist>
      <bridgehead renderas="sect3">Short Descriptions</bridgehead>
      <?dbfo list-presentation="list"?>
      <?dbhtml list-presentation="table"?>

      <!-- If the program or library name conflicts with (is the same as) the
      package name, add -prog or -lib to the varlistentry entity id
      and the 2nd entry of the indexterm zone entity -->

      <varlistentry id="freerdp-proxy">
        <term><command>freerdp-proxy</command></term>
        <listitem>
          <para>
            configures FreeRDP to use a proxy server
          </para>
          <indexterm zone="freerdp freerdp-proxy">
            <primary sortas="b-freerdp-proxy">freerdp-proxy</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="freerdp-shadow-cli">
        <term><command>freerdp-shadow-cli</command></term>
        <listitem>
          <para>
            interfaces with the shadow functionality in FreeRDP
          </para>
          <indexterm zone="freerdp freerdp-shadow-cli">
            <primary sortas="b-freerdp-shadow-cli">freerdp-shadow-cli</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="sfreerdp">
        <term><command>sfreerdp</command></term>
        <listitem>
          <para>
            is a utility for sharing an X display over RDP
          </para>
          <indexterm zone="freerdp sfreerdp">
            <primary sortas="b-sfreerdp">sfreerdp</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="sfreerdp-server">
        <term><command>sfreerdp-server</command></term>
        <listitem>
          <para>
            is a utility for sharing an X display over RDP
          </para>
          <indexterm zone="freerdp sfreerdp-server">
            <primary sortas="b-sfreerdp-server">sfreerdp-server</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="winpr-hash">
        <term><command>winpr-hash</command></term>
        <listitem>
          <para>
            creates a NTLM hash from a username and password pair
          </para>
          <indexterm zone="freerdp winpr-hash">
            <primary sortas="b-winpr-hash">winpr-hash</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="winpr-makecert">
        <term><command>winpr-makecert</command></term>
        <listitem>
          <para>
            creates X.509 certificates for use with FreeRDP
          </para>
          <indexterm zone="freerdp winpr-makecert">
            <primary sortas="b-winpr-makecert">winpr-makecert</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="wlfreerdp">
        <term><command>wlfreerdp</command></term>
        <listitem>
          <para>
            is a RDP client for Wayland
          </para>
          <indexterm zone="freerdp wlfreerdp">
            <primary sortas="b-wlfreerdp">wlfreerdp</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="xfreerdp">
        <term><command>xfreerdp</command></term>
        <listitem>
          <para>
            is a RDP client for X11
          </para>
          <indexterm zone="freerdp xfreerdp">
            <primary sortas="b-xfreerdp">xfreerdp</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="libfreerdp3">
        <term><filename class="libraryfile">libfreerdp3.so</filename></term>
        <listitem>
          <para>
            contains functions that provide RDP client and server functionality
          </para>
          <indexterm zone="freerdp libfreerdp3">
            <primary sortas="c-libfreerdp3">libfreerdp3.so</primary>
          </indexterm>
        </listitem>
      </varlistentry>
    </variablelist>
  </sect2>
</sect1>
